#!/usr/bin/env python3
#-*- coding: utf-8 -*-

#
# (c) Simon Psenner, iteas IT Services GmbH
# simon.psenner@iteas.at
# www.iteas.at
#

import os
import subprocess

from flask import Flask, jsonify, request
from flask_restful import reqparse, abort, Api, Resource

app = Flask(__name__)
api = Api(app)


@app.route('/')
def index():
    return "Hello World!"


# Todo How to deal with multiple Printjobs at a time

class PrintAroma(Resource):
    def post(self):
        json_data = request.get_json(force=True)

        with open('/var/lib/printserver-templates/aroma19.zpl', 'r') as myfile:
            data = myfile.read()

        barcode = json_data["barcode"]  # 30000118777000050102040
        country = json_data["country"]  # AT
        lotnumber = json_data["lotnumber"]  # 1877700005
        suppliernumber = json_data["supplier"]  # 300001
        ggnr = json_data["ggnr"] #Zertifikatsnumber
        suppliername = json_data["suppliername"] #Franz Huber
        prodnr = json_data["prodnr"]  # 102
        prodname = json_data["prodname"]  # Idared

        farmnr = json_data["farmnr"]  # 2548
        farmname = json_data["farmname"] # Anlage B45

        amount = json_data["amount"] # 40
        container = json_data["container"] #GKP
        
        certs = json_data["certs"]  # GGAP
        lsnr = json_data["lsnr"] #Lieferscheinnumber
        year = json_data["year"]  # 2019    
        deliverydate = json_data["deliverydate"]  # 02.11.2017

        pages = json_data["pages"]  # 2

        with open("/tmp/aromaout.zpl", "w+") as file:
            file.write(data % (barcode, country, lotnumber, suppliernumber, ggnr, suppliername, prodnr, prodname, farmnr, farmname, amount, container, certs, lsnr, year, deliverydate,pages))

        subprocess.call(["lpr -PZebra_ZD420 -o raw /tmp/aromaout.zpl"], shell=True)
        #count = 0
        #while count < pages:
        #    count += 1
        #    print("printing")
        #    subprocess.call(["lpr -PZebra_ZD420 -o raw /tmp/aromaout.zpl"], shell=True)

        return jsonify(message="Printjob Recived")


class PrintMeleco(Resource):
    def post(self):
        json_data = request.get_json(force=True)

        with open('/var/lib/printserver-templates/meleco19.zpl', 'r') as myfile:
            data = myfile.read()

        barcode = json_data["barcode"]  # 30000118777000050102040
        country = json_data["country"]  # AT
        lotnumber = json_data["lotnumber"]  # 1877700005
        ggnr = json_data["ggnr"]  # Zertifikatsnumber
        suppliername = json_data["suppliername"]  # Franz Huber
        prodname = json_data["prodname"]  # Idared
        farmname = json_data["farmname"]
        amount = json_data["amount"]  # 40
        container = json_data["container"]  # GKP
        certs = json_data["certs"]  # GGAP
        lsnr = json_data["lsnr"]  # Lieferscheinnumber
        year = json_data["year"]  # 2017
        deliverydate = json_data["deliverydate"]  # 02.11.2017
        pages = json_data["pages"]  # 2

        with open("/tmp/melecoout.zpl", "w+") as file:
            file.write(data % (barcode, country, lotnumber, ggnr, suppliername, prodname, farmname, amount, container, certs, lsnr, year, deliverydate, pages))

        print("printing")
        subprocess.call(["lpr -PZebra_ZD420 -o raw /tmp/melecoout.zpl"], shell=True)

api.add_resource(PrintAroma, '/aroma')
api.add_resource(PrintMeleco, '/meleco')

if __name__ == "__main__":
    app.run(host='0.0.0.0', port=8080, debug=True)
